#ifndef APPS_GLOBAL_PREFERENCES_H
#define APPS_GLOBAL_PREFERENCES_H

#include <apps/i18n.h>

extern "C" {
  //extern int persistance_restart;
}

class GlobalPreferences {
public:
  enum class ExamMode {
    Activate,
    Deactivate
  };
  static GlobalPreferences * sharedGlobalPreferences();
  I18n::Language language() const { return m_language; }
  void setLanguage(I18n::Language language) { m_language = language; }
  ExamMode examMode() const { return m_examMode; }
  void setExamMode(ExamMode examMode) { m_examMode = examMode; /* persistance_restart=(examMode==ExamMode::Activate?12345678:0);*/ }
  bool showPopUp() const { return m_showPopUp; }
  void setShowPopUp(bool showPopUp) { m_showPopUp = showPopUp; }
  int brightnessLevel() const { return m_brightnessLevel; }
  void setBrightnessLevel(int brightnessLevel);
  constexpr static int NumberOfBrightnessStates = 5;
private:
  GlobalPreferences() :
    m_language(I18n::Language::FR),
    m_examMode(ExamMode::Deactivate),
    m_showPopUp(true),
    m_brightnessLevel(Ion::Backlight::MaxBrightness / 3) {}
  I18n::Language m_language;
  ExamMode m_examMode;
  bool m_showPopUp;
  int m_brightnessLevel;
};

#endif
